module.exports = class LibraryEntrance {
	constructor() {
		this.id = this.constructor.name;
		this.name = "Library Entrance";
		this.description = "The light marble floor reflects the towering archway into the library.";
		this.filename = "library/entrance.js";
		this.type = "room";
		this.items = [];
		this.mobiles = [];
		this.roomExits = [];
		this.roomExpires = 0;
		this.resetDelay = 12000000;
		this.roomExits = ["north", "south"];
	}

	mud_reset(time) {
		libs.Output.toRoom(this.id, "A page turns in the utter silence.\n");
		this.roomExpires = time + this.resetDelay;
	}

	mud_tick(time) {
		if(time >= this.roomExpires) {
			this.mud_reset(time);
		}
	}

	north(room, mobile, input) {
		world.mud_moveMobile(mobile.id, this.id, "LibraryBookReturn");
		return true;
	}

	south(room, mobile, input) {
		world.mud_moveMobile(mobile.id, this.id, "Void1");
		return true;
	}
};
